// 20 mmm pipe holder aka. thermometer holder
// Written by Pawel Tatera
// Copyright TinyIT, all right reserved

// Note
// If you play with gripRotate negative/positive values, you can create
// left/right side grips.


dPipe=20;		// srednica szklanej rurki
wallThick=2;	// grubosc scianki oprawki
zPipe=10;		// wysokosc uchwytu rurki

gripStart=1.4;
gripFit=10;
gripThick=5;		// grubosc ramienia
gripRange=20;		// dlugosc ramienia
gripMount=16;		// docisk do sciany
gripRotate=45;		// skos docisku
// >=0: [ lewy_dol | prawy_gora ]
// <0 : [ lewy_gora | prawy_dol ]
// F5 to refresh
dHole=3;		// otwor montazowy

$fa = 1;
$fs = 1;


// Oprawka
difference() {

	union(){
		// oprawka
		cylinder(zPipe, (dPipe+wallThick*2)/2, (dPipe+wallThick*2)/2,false);

		// poczatek uchwytu
		translate([gripStart,gripStart,0]) cube(gripFit,false);
	}

	// kanal wpustowy
	translate([0,0,wallThick]) 	cylinder(zPipe, dPipe/2, dPipe/2, false);
}


// Uchwyt
rotate(45){
	// ramie
	gripTrim=sqrt(2*gripFit*gripFit)-gripThick;
	translate([gripStart+gripTrim, -gripThick/2, 0])
		cube([gripRange,gripThick,gripFit],false);

	// mocowanie do sciany
	if(gripRotate>=0){ // lewy_dol | prawy_gora
		translate([gripStart+gripRange+gripTrim, -gripThick/2, 0])
			rotate(gripRotate)
			    difference(){
			    cube([gripMount,gripThick,gripFit],false);

			    translate([gripMount/2,gripThick+.5,gripFit/2])
				rotate([90,0,0])
				    cylinder(gripThick+1, dHole/2, dHole/2,false);
			}

	} else {  // lewy_gora | prawy_dol
		translate([gripStart+gripRange+gripTrim, gripThick/2, 0])
			mirror([0,1,0])
				rotate(a=-gripRotate,v=[0,0,1])
				    difference(){
						cube([gripMount,gripThick,zPipe],false);

						translate([gripMount/2,gripThick+.5,gripMount/2])
						    rotate([90,0,0])
							cylinder(gripThick+1, dHole/2, dHole/2,false);
					}

	}

}

